import { Injector, Type } from '@angular/core';
import { createCustomElement } from '@angular/elements';
import { MyGanttTaskTooltipComponent } from './components/gantt-task-tooltip/gantt-task-tooltip.component';

export class GanttCustomElementsInitializer {
  static iniitalize(injector: Injector):  void {
    this.createElement('gantt-task-tooltip', MyGanttTaskTooltipComponent, injector);
  }

  private static createElement(selector: string, componentType: Type<any>, customInjector: Injector): void {
    const existingElement: any | null = customElements.get(selector);

    if (existingElement != null) {
      return;
    }

    customElements.define(selector, createCustomElement(componentType, {
      injector: customInjector
    }));
  }
}
